<?php

namespace App\DataFixtures;

use App\Entity\MerBeDM;
use App\Entity\MerBeSub;
use App\Entity\MerParaDM;
use App\Entity\MerParaDT;
use App\Entity\MerParaSub;
use App\Enum\SubStatus;
use Doctrine\Bundle\FixturesBundle\Fixture;
use Doctrine\Persistence\ObjectManager;

class MerFixtures extends Fixture
{
    public function load(ObjectManager $manager): void
    {
        $ser1 = new MerParaDM();
        $ser1->setMccMnc(12345)
            ->setOfferId(221)
            ->setProductCode('code1');

        $ser2 = new MerParaDM();
        $ser2->setMccMnc(12345)
            ->setOfferId(223)
            ->setProductCode('code2');

        $ser3 = new MerParaDT();
        $ser3->setMccMnc(12345)
            ->setServiceId('ser-vi-ce1')
            ->setApiKey('api1');

        $ser4 = new MerParaDT();
        $ser4->setMccMnc(12341)
            ->setServiceId('ser-vi-ce2')
            ->setApiKey('api2');

        $ser5 = new MerBeDM();
        $ser5->setMccMnc(12341)
            ->setOfferId(112)
            ->setActivationCode('active1');

        $sub1 = new MerParaSub();
        $sub1->setService($ser1)
            ->setStatus(SubStatus::ACTIVE)
            ->setPin(1122)
            ->setSubDate(new \DateTimeImmutable('now'));

        $sub2 = new MerParaSub();
        $sub2->setService($ser3)
            ->setStatus(SubStatus::PREREGISTERED)
            ->setPin(2211)
            ->setSubDate(new \DateTimeImmutable('now'));

        $sub3 = new MerParaSub();
        $sub3->setService($ser3)
            ->setStatus(SubStatus::CANCELLED)
            ->setSubDate(new \DateTimeImmutable('yesterday'))
            ->setUnsubDate(new \DateTimeImmutable('now'));

        $sub4 = new MerBeSub();
        $sub4->setService($ser5)
            ->setStatus(SubStatus::REGISTERED)
            ->setCode('CoDe')
            ->setSubDate(new \DateTimeImmutable('now'));

        $manager->persist($ser1);
        $manager->persist($ser2);
        $manager->persist($ser3);
        $manager->persist($ser4);
        $manager->persist($ser5);

        $manager->persist($sub1);
        $manager->persist($sub2);
        $manager->persist($sub3);
        $manager->persist($sub4);

        $manager->flush();
    }
}

// symfony console doctrine:fixtures:load
